Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/DefaultDataSwingManager.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/DefaultDataSwingManager.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/DefaultDataSwingManager.java	(revision 46050)
@@ -110,6 +110,7 @@
 import org.gvsig.fmap.dal.swing.featuretable.SimpleFeaturesTableModel;
 import org.gvsig.fmap.dal.swing.featuretype.FeatureAttributeListCellRenderer;
 import org.gvsig.fmap.dal.swing.featuretype.FeatureAttributesSelectionPanel;
+import org.gvsig.fmap.dal.swing.impl.actions.GraphAction.GraphActionFactory;
 import org.gvsig.fmap.dal.swing.impl.expressionevaluator.suggestions.CheckTableFieldsSuggestionProviderFactory;
 import org.gvsig.fmap.dal.swing.impl.expressionevaluator.suggestions.QuotesForFieldNameSuggestionProviderFactory;
 import org.gvsig.fmap.dal.swing.impl.expressionevaluator.suggestions.StorePointFieldSuggestionProviderFactory;
@@ -135,6 +136,7 @@
         this.registerStoreAction(new SelectionFilterActionFactory());
         this.registerStoreAction(new SelectionSetActionFactory());
         this.registerStoreAction(new ShowFormActionFactory());
+        this.registerStoreAction(new GraphActionFactory());
         
         this.searchPostProcess = new HashMap<>();
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/AbstractDALActionFactory.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/AbstractDALActionFactory.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/AbstractDALActionFactory.java	(revision 46050)
@@ -74,7 +74,7 @@
     }
 
     @Override
-    public boolean isApplicable(DALActionContext context) {
+    public boolean isApplicable(Object... args) {
         return true;
     }
     
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/featuretable/SimpleFeaturesTableModel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/featuretable/SimpleFeaturesTableModel.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/featuretable/SimpleFeaturesTableModel.java	(revision 46050)
@@ -22,7 +22,9 @@
 package org.gvsig.fmap.dal.swing.featuretable;
 
 import java.util.List;
+import java.util.Map;
 import javax.swing.JTable;
+import javax.swing.table.TableCellRenderer;
 import javax.swing.table.TableModel;
 import org.gvsig.fmap.dal.feature.Feature;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
@@ -41,6 +43,8 @@
 
     public void setCellRenderers(JTable table);
     
+    public void setCellRenderers(JTable table, Map<String, TableCellRenderer> renderers);
+    
     public FeatureAttributeDescriptor getFeatureDescriptor(int columnIndex);
     
     public Feature getFeatureAt(int rowIndex);
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/DALActionFactory.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/DALActionFactory.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.api/src/main/java/org/gvsig/fmap/dal/swing/DALActionFactory.java	(revision 46050)
@@ -6,12 +6,13 @@
 import org.gvsig.fmap.dal.DataStore;
 import org.gvsig.fmap.dal.feature.FeatureQuery;
 import org.gvsig.fmap.dal.feature.FeatureQueryOrder;
+import org.gvsig.tools.util.IsApplicable;
 
 /**
  *
  * @author jjdelcerro
  */
-public interface DALActionFactory {
+public interface DALActionFactory extends IsApplicable {
 
     public interface DALActionContext {
         public String getName();
@@ -29,7 +30,14 @@
     
     public String getName();
 
-    public boolean  isApplicable(DALActionContext context);
+    /**
+     * Check if this factory is applicable to the first argument.
+     * The first argument can be instanceof DALActionContext
+     * @param args
+     * @return 
+     */
+    @Override
+    public boolean isApplicable(Object... args);
     
     public Action createAction(DALActionContext context);
     
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/AbstractStoresRepository.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/AbstractStoresRepository.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/AbstractStoresRepository.java	(revision 46050)
@@ -2,13 +2,16 @@
 
 import java.util.ArrayList;
 import java.util.Collection;
+import java.util.Collections;
 import java.util.Iterator;
 import java.util.List;
 import java.util.Map;
+import java.util.Objects;
 import org.apache.commons.lang3.StringUtils;
 import org.gvsig.tools.observer.Notification;
 import org.gvsig.tools.observer.ObservableHelper;
 import org.gvsig.tools.observer.Observer;
+import org.gvsig.tools.util.PropertiesSupport;
 import org.gvsig.tools.util.UnmodifiableBasicSet;
 import org.gvsig.tools.util.UnmodifiableBasicSetChained;
 import org.slf4j.Logger;
@@ -157,15 +160,44 @@
         }
         return null;
     }
+    
+     public PropertiesSupport getProperties(String name) {
+         return new PropertiesSupport() {
+             @Override
+             public Object getProperty(String name) {
+                 return null;
+             }
 
+             @Override
+             public void setProperty(String name, Object value) {
+                 
+             }
+
+             @Override
+             public Map<String, Object> getProperties() {
+                 return Collections.EMPTY_MAP;
+             }
+         };
+     }
+    
     @Override
     public DataStore getStore(String name) {
+        PropertiesSupport properties = this.getProperties(name);
+        if(properties!=null && 
+                StringUtils.equalsIgnoreCase(Objects.toString(properties.getProperty("ignoreDALResource")),"true")) {
+            return this.getStore(name, true);
+        }
+        return this.getStore(name, false);
+    }
+
+    public DataStore getStore(String name, boolean ignoreDALResource) {
         DataStoreParameters parameters = this.getMyParameters(name);
         if( parameters!=null ) {
             try {
                 DataStore store = DALLocator.getDataManager().openStore(
                         parameters.getDataStoreName(), 
-                        parameters
+                        parameters,
+                        ignoreDALResource
                 );
                 return store;
             } catch (Exception ex) {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/BaseStoresRepository.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/BaseStoresRepository.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/BaseStoresRepository.java	(revision 46050)
@@ -4,6 +4,7 @@
 import java.util.Map;
 import java.util.Set;
 import org.apache.commons.lang3.StringUtils;
+import org.gvsig.tools.util.PropertiesSupport;
 import org.gvsig.tools.util.UnmodifiableBasicSet;
 import org.gvsig.tools.util.UnmodifiableBasicSetAdapter;
 
@@ -48,9 +49,17 @@
         }
         return new UnmodifiableBasicSetAdapter<>(keyset);
     }
-
+    
+    public PropertiesSupport getProperties(String name) {
+        return null;
+    }
+    
     @Override
     public void add(String name, DataStoreParameters parameters) {
+        this.add(name, parameters, null);
+    }
+    
+    public void add(String name, DataStoreParameters parameters, PropertiesSupport properties) {
         if( parameters == null ) {
             throw new IllegalArgumentException("parameters can't be null.");
         }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/SQLBuilderBase.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/SQLBuilderBase.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.spi/src/main/java/org/gvsig/fmap/dal/feature/spi/SQLBuilderBase.java	(revision 46050)
@@ -51,6 +51,7 @@
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.geom.Geometry;
 import org.gvsig.tools.dataTypes.DataType;
+import org.gvsig.tools.util.PropertiesSupportHelper;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
@@ -2600,6 +2601,7 @@
     
     @Override
     public void setProperties(Class filter, final Object... values) {
+        this.expressionBuilder.setProperties(filter, values);
         this.accept(new Visitor() {
             @Override
             public void visit(Visitable v) {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeature.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeature.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeature.java	(revision 46050)
@@ -912,7 +912,10 @@
 //            int index = featureAttributeDescriptor.getIndex();
 //            value = this.data.get(index);
 //            if( value==null ) {
-            value = emulator.get(this);
+            value = this.getExtraValue(featureAttributeDescriptor.getName());
+            if (value==null) {
+                value = emulator.get(this);
+            }
 //                this.data.set(index,value);
 //            }
         } else {
@@ -1346,10 +1349,20 @@
     @Override
     public String getLabelOfValue(String name) {
         FeatureAttributeDescriptor attrdesc = this.data.getType().getAttributeDescriptor(name);
-        if (attrdesc == null) {
-            throw new IllegalArgumentException("Attribute name '" + name + "' not found in the feature.");
+        Object value;
+        if (attrdesc == null) { // extra column
+            FeatureExtraColumns extraColumns = this.data.getType().getExtraColumns();
+            if (extraColumns==null) {
+                return name;
+            }
+            attrdesc = extraColumns.get(name);
+            if(attrdesc==null) {
+                return name;
+            }
+           value = this.get(name);
+        } else {
+           value = this.get(attrdesc.getIndex());
         }
-        Object value = this.get(attrdesc.getIndex());
         String label = attrdesc.getLabelOfValue(value);
         return label;
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/ResultSetForSetProviderOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/ResultSetForSetProviderOperation.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/ResultSetForSetProviderOperation.java	(revision 46050)
@@ -52,11 +52,13 @@
 import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase;
 import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_FEATURE_TYPE;
 import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_JDBCHELPER;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_QUERY;
 import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_SYMBOLTABLE;
 import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_TABLE;
 import org.gvsig.fmap.geom.DataTypes;
 import org.gvsig.tools.dynobject.DynField;
 import org.gvsig.tools.evaluator.Evaluator;
+import org.gvsig.tools.util.ContainerUtils;
 
 public class ResultSetForSetProviderOperation extends AbstractConnectionOperation {
 
@@ -117,7 +119,7 @@
             List<FeatureAttributeDescriptor> columns,
             List<String> extraColumnNames
     ) {
-        double tolerance = -1; //query.getScale();
+        double tolerance = -1; //query.getScale(); 
         ExpressionBuilder expbuilder = sqlbuilder.expression();
         SelectBuilder select = sqlbuilder.select();
 
@@ -141,22 +143,48 @@
         if (query != null && query.hasConstantsAttributeNames()) {
             constantsAttributeNames = query.getConstantsAttributeNames();
         }
+        ArrayList<ExpressionBuilder.Value> valuesToRemoveFeatureType = new ArrayList<>();
         for (FeatureAttributeDescriptor attr : setType) {
             if (attr.isComputed()) {
-//              if(StringUtils.isNotBlank(System.getenv("ENABLE_COMPUTED_SQL_ATTR"))) {
+//              if(StringUtils.isNotBlank(System.getenv("ENABLE_COMPUTED_SQL_ATTR"))) { 
                 if (attr.getRelationType() == DynField.RELATION_TYPE_NONE) {
                     FeatureAttributeEmulator attrEmulator = attr.getFeatureAttributeEmulator();
                     if (attrEmulator instanceof FeatureAttributeEmulatorExpression) {
                         FeatureAttributeEmulatorExpression x = (FeatureAttributeEmulatorExpression) attrEmulator;
                         Expression exp = x.getExpression();
-                        if (exp != null && !exp.isEmpty() && this.helper.supportExpression(setType, exp.getPhrase())) {
-                            Code code = exp.getCode();
-                            select.column()
-                                    .value(code.toValue(expbuilder))
-                                    .as(attr.getName());
-                            if (!extraColumnNames.contains(attr.getName())) {
-                                extraColumnNames.add(attr.getName());
+
+                        if (query != null && query.hasGroupByColumns()) {
+                            String aggregate = query.getAggregate(this.table.getTable(), attr.getName());
+                            if (this.query.isAGroupByColumn(attr.getName())) {
+                                if (!select.has_column(attr.getName())) {
+                                    select.column().value(exp.getCode().toValue()).as(attr.getName());
+                                }
+                                if (extraColumnNames != null && !extraColumnNames.contains(attr.getName())) {
+                                    extraColumnNames.add(attr.getName());
+                                }
+                            } else if (aggregate == null) {
+                                select.column().value(expbuilder.constant(null)).as(attr.getName());
+                            } else {
+                                String fn = this.query.getAggregateFunctions().get(attr.getName());
+                                ExpressionBuilder.Function aggregateExp = expbuilder.function(fn, exp.getCode().toValue());
+                                if (!select.has_column(attr.getName())) {
+                                    select.column().value(aggregateExp).as(attr.getName());
+                                }
+                                if (extraColumnNames != null && !extraColumnNames.contains(attr.getName())) {
+                                    extraColumnNames.add(attr.getName());
+                                }
                             }
+                        } else {
+                            if (exp != null && !exp.isEmpty() && this.helper.supportExpression(setType, exp.getPhrase())) {
+                                Code code = exp.getCode();
+                                select.column()
+                                        .value(code.toValue(expbuilder))
+                                        .as(attr.getName());
+                                if (extraColumnNames != null && !extraColumnNames.contains(attr.getName())) {
+                                    extraColumnNames.add(attr.getName());
+                                }
+                            }
+
                         }
                     }
                 }
@@ -209,7 +237,7 @@
                     if (!select.has_column(attr.getName())) {
                         select.column().value(aggregateExp).as(attr.getName());
                     }
-                    if (!extraColumnNames.contains(attr.getName())) {
+                    if (extraColumnNames!=null && !extraColumnNames.contains(attr.getName())) {
                         extraColumnNames.add(attr.getName());
                     }
                 }
@@ -217,22 +245,29 @@
             for (String attrName : query.getGroupByColumns()) {
                 if (allExtraColumns.get(attrName) != null) { //from setType and query
                     EditableFeatureAttributeDescriptor attr = allExtraColumns.get(attrName);
-                    select.group_by(expbuilder.column(attrName));
+                    ExpressionBuilder.Variable col = expbuilder.column(attrName);
+                    select.group_by(col);
+                    // En el groupBy no queremos que se sustituya el nombre del campo calculado
+                    // por su expresion. Se encarga el formater y lo evitamos quitandole el ftype
+                    // al value.
+                    valuesToRemoveFeatureType.add(col);
                     Expression exp = ((FeatureAttributeEmulatorExpression) attr.getFeatureAttributeEmulator()).getExpression();
                     if (!select.has_column(attrName)) {
                         select.column().value(exp.getCode().toValue()).as(attrName);
                     }
-                    if (!extraColumnNames.contains(attr.getName())) {
+                    if (extraColumnNames!=null && !extraColumnNames.contains(attr.getName())) {
                         extraColumnNames.add(attrName);
                     }
                 } else if (setType.get(attrName) != null && setType.getAttributeDescriptor(attrName).isComputed()) {
                     FeatureAttributeDescriptor attr = setType.getAttributeDescriptor(attrName);
-                    select.group_by(expbuilder.column(attrName));
+                    ExpressionBuilder.Variable col = expbuilder.column(attrName);
+                    select.group_by(col);
+                    valuesToRemoveFeatureType.add(col);
                     Expression exp = ((FeatureAttributeEmulatorExpression) attr.getFeatureAttributeEmulator()).getExpression();
                     if (!select.has_column(attrName)) {
                         select.column().value(exp.getCode().toValue()).as(attrName);
                     }
-                    if (!extraColumnNames.contains(attr.getName())) {
+                    if (extraColumnNames!=null && !extraColumnNames.contains(attr.getName())) {
                         extraColumnNames.add(attrName);
                     }
                 } else if (setType.get(attrName) == null) {
@@ -268,7 +303,7 @@
                                 select.column()
                                         .value(code.toValue(expbuilder))
                                         .as(attr.getName());
-                                if (!extraColumnNames.contains(attr.getName())) {
+                                if (extraColumnNames!=null && !extraColumnNames.contains(attr.getName())) {
                                     extraColumnNames.add(attr.getName());
                                 }
                             }
@@ -312,7 +347,7 @@
                         if (!select.has_column(attrName)) {
                             select.column().value(exp.getCode().toValue()).as(attrName);
                         }
-                        if (!extraColumnNames.contains(attrName)) {
+                        if (extraColumnNames!=null && !extraColumnNames.contains(attrName)) {
                             extraColumnNames.add(attrName);
                         }
                     } else if (setType.get(attrName) != null && setType.getAttributeDescriptor(attrName).isComputed()) {
@@ -320,7 +355,7 @@
                         if (!select.has_column(attrName)) {
                             select.column().value(exp.getCode().toValue()).as(attrName);
                         }
-                        if (!extraColumnNames.contains(attrName)) {
+                        if (extraColumnNames!=null && !extraColumnNames.contains(attrName)) {
                             extraColumnNames.add(attrName);
                         }
                     }
@@ -386,8 +421,12 @@
                 PROP_FEATURE_TYPE, this.storeType,
                 PROP_TABLE, table,
                 PROP_SYMBOLTABLE, this.query==null? null:this.query.getSymbolTable(),
-                PROP_JDBCHELPER, this.helper
+                PROP_JDBCHELPER, this.helper,
+                PROP_QUERY, this.query
         );
+        for (ExpressionBuilder.Value value : valuesToRemoveFeatureType) {
+            value.setProperty(PROP_FEATURE_TYPE, null);
+        }
         this.helper.processSpecialFunctions(sqlbuilder, storeType, extraColumnNames);
         String sql = sqlbuilder.toString();
         return sql;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CountOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CountOperation.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/CountOperation.java	(revision 46050)
@@ -27,6 +27,7 @@
 import java.sql.ResultSet;
 import java.sql.SQLException;
 import java.sql.Statement;
+import java.util.ArrayList;
 import java.util.List;
 import org.apache.commons.lang3.StringUtils;
 import org.gvsig.expressionevaluator.Code;
@@ -38,6 +39,8 @@
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.expressionevaluator.FeatureAttributeEmulatorExpression;
 import org.gvsig.fmap.dal.feature.EditableFeatureAttributeDescriptor;
+import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
+import org.gvsig.fmap.dal.feature.FeatureAttributeEmulator;
 import org.gvsig.fmap.dal.feature.FeatureQuery;
 import org.gvsig.fmap.dal.feature.FeatureQueryOrder;
 import org.gvsig.fmap.dal.feature.FeatureType;
@@ -48,8 +51,10 @@
 import org.gvsig.fmap.dal.store.jdbc2.OperationsFactory.TableReference;
 import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_FEATURE_TYPE;
 import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_JDBCHELPER;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_QUERY;
 import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_SYMBOLTABLE;
 import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_TABLE;
+import org.gvsig.tools.dynobject.DynField;
 import org.gvsig.tools.evaluator.Evaluator;
 
 public class CountOperation extends AbstractConnectionOperation {
@@ -89,10 +94,57 @@
         ExpressionBuilder expbuilder = sqlbuilder.expression();
 
         SelectBuilder select = sqlbuilder.select();
+        ArrayList<ExpressionBuilder.Value> valuesToRemoveFeatureType = new ArrayList<>();
 
         if (this.query != null && this.query.hasGroupByColumns()) {
             JDBCSQLBuilderBase subsqlbuilder = this.createSQLBuilder();
             SelectBuilder subselect = subsqlbuilder.select();
+            
+            subselect.column().value(subsqlbuilder.count().all());
+            for (FeatureAttributeDescriptor attr : this.featureType) {
+                if (attr.isComputed()) {
+                    if (attr.getRelationType() == DynField.RELATION_TYPE_NONE) {
+                        FeatureAttributeEmulator attrEmulator = attr.getFeatureAttributeEmulator();
+                        if (attrEmulator instanceof FeatureAttributeEmulatorExpression) {
+                            FeatureAttributeEmulatorExpression x = (FeatureAttributeEmulatorExpression) attrEmulator;
+                            Expression exp = x.getExpression();
+
+                            if (query != null && query.hasGroupByColumns()) {
+                                String aggregate = query.getAggregate(this.table.getTable(), attr.getName());
+                                if (this.query.isAGroupByColumn(attr.getName())) {
+                                    if (!subselect.has_column(attr.getName())) {
+                                        subselect.column().value(exp.getCode().toValue()).as(attr.getName());
+                                    }
+                             
+                                } else if (aggregate == null) {
+                                    subselect.column().value(expbuilder.constant(null)).as(attr.getName());
+                                } else {
+                                    String fn = this.query.getAggregateFunctions().get(attr.getName());
+                                    ExpressionBuilder.Function aggregateExp = expbuilder.function(fn, exp.getCode().toValue());
+                                    if (!subselect.has_column(attr.getName())) {
+                                        subselect.column().value(aggregateExp).as(attr.getName());
+                                    }
+                                
+                                }
+                            } else {
+                                if (exp != null && !exp.isEmpty() && this.helper.supportExpression(this.featureType, exp.getPhrase())) {
+                                    Code code = exp.getCode();
+                                    subselect.column()
+                                            .value(code.toValue(expbuilder))
+                                            .as(attr.getName());
+                                
+                                }
+
+                            }
+                        }
+                    }
+                }
+            }
+            
+            
+            
+            
+            
             if (this.query.hasGroupByColumns()) {
                 if (this.query.hasOrder()) {
                     FeatureQueryOrder order = query.getOrder();
@@ -113,7 +165,6 @@
                         }
                     }
                 }
-                subselect.column().value(subsqlbuilder.count().all());
                 subselect.from().table()
                         .database(this.table.getDatabase())
                         .schema(this.table.getSchema())
@@ -171,7 +222,11 @@
                 this.helper.processSpecialFunctions(subsqlbuilder, featureType, null);
                 subsqlbuilder.setProperties(
                         ExpressionBuilder.Variable.class,
-                        PROP_TABLE, table
+                        PROP_FEATURE_TYPE, this.featureType,
+                        PROP_TABLE, table,
+                        PROP_SYMBOLTABLE, this.query == null ? null : this.query.getSymbolTable(),
+                        PROP_JDBCHELPER, this.helper,
+                        PROP_QUERY, this.query
                 );
                 String subsql = subselect.toString();
                 select.from().table()
@@ -211,7 +266,8 @@
                 PROP_FEATURE_TYPE, this.featureType,
                 PROP_TABLE, table,
                 PROP_SYMBOLTABLE, this.query==null? null:this.query.getSymbolTable(),
-                PROP_JDBCHELPER, this.helper
+                PROP_JDBCHELPER, this.helper,
+                PROP_QUERY, this.query
         );
 
         String sql = select.toString();
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCSQLBuilderBase.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCSQLBuilderBase.java	(revision 46049)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCSQLBuilderBase.java	(revision 46050)
@@ -66,6 +66,7 @@
     public static final String PROP_TABLE = "Table";
     public static final String PROP_SYMBOLTABLE = "SymbolTable";
     public static final String PROP_JDBCHELPER = "JDBCHelper";
+    public static final String PROP_QUERY = "Query";
     
     private GeometryManager geometryManager = null;
     protected final JDBCHelper helper;
